package table_viewer;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ComboBoxCellEditor;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.ui.part.ViewPart;

/**
 * eXgʂ\r[
 */
public class TestResultView extends ViewPart {

    /**
     * RXgN^
     */
    public TestResultView() {
        super();
    }

    /**
     * ʂ̏
     */
    public void createPartControl(Composite parent) {
        // e[ur[A̐
        TableViewer testResultViewer = new TableViewer(parent, SWT.MULTI | SWT.VIRTUAL
                | SWT.H_SCROLL | SWT.V_SCROLL);

        // e[u̐
        Table testResultTable = testResultViewer.getTable();

        // Z̋Eɂ
        testResultTable.setLinesVisible(true);
        // wb_ɂ
        testResultTable.setHeaderVisible(true);

        // wb_ݒ
        TableColumn col = new TableColumn(testResultTable, SWT.LEFT);
        col.setText("oȔԍ");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.LEFT);
        col.setText("");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("p");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("w");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("");
        col.setWidth(80);

        col = new TableColumn(testResultTable, SWT.RIGHT);
        col.setText("]");
        col.setWidth(80);

        // RecvoC_̐ݒ
        testResultViewer.setContentProvider(new ArrayContentProvider());
        // xvoC_̐ݒ
        testResultViewer.setLabelProvider(new TestResultLabelProvider());

        // Jʂ邽߂̃vpeB
        String[] properties = new String[] { "id", "name", "english_score", "mathematics_score",
                "japanese_score", "evaluation" };

        // vpeB̐ݒ
        testResultViewer.setColumnProperties(properties);

        // ComboBoxCelEditorɕ\ACe
        String[] evaluationItems = new String[] { "", "A", "B", "C", "D", "E" };

        // ZGfB^̐
        CellEditor[] cellEditors = new CellEditor[] { new TextCellEditor(testResultTable),
                new TextCellEditor(testResultTable), new TextCellEditor(testResultTable),
                new TextCellEditor(testResultTable), new TextCellEditor(testResultTable),
                new ComboBoxCellEditor(testResultTable, evaluationItems) };
        // ZGfB^̐ݒ
        testResultViewer.setCellEditors(cellEditors);

        // ZfBt@C̐ݒ
        testResultViewer.setCellModifier(new TestResultCellModifier(testResultViewer, evaluationItems));
        // }EXA_v^̐ݒ
        testResultTable.addMouseListener( new TestResultTableMouseAdapter( testResultViewer));
        
        // f[^̐ݒ
        testResultViewer.setInput(getTestResult());

    }

    /**
     * _~[̕\f[^擾
     * @return eXgʂ̃Xg
     */
    private List getTestResult() {
        List resultList = new ArrayList();

        TestResult result = new TestResult();
        result.setId(1);
        result.setName("X ms");
        result.setEnglishScore(getRandom());
        result.setMathematicsScore(getRandom());
        result.setJapaneseScore(getRandom());
        resultList.add(result);

        result = new TestResult();
        result.setId(2);
        result.setName(" N");
        result.setEnglishScore(getRandom());
        result.setMathematicsScore(getRandom());
        result.setJapaneseScore(getRandom());
        resultList.add(result);

        result = new TestResult();
        result.setId(3);
        result.setName("쑺@");
        result.setEnglishScore(getRandom());
        result.setMathematicsScore(getRandom());
        result.setJapaneseScore(getRandom());
        resultList.add(result);

        result = new TestResult();
        result.setId(4);
        result.setName("ɓ@");
        result.setEnglishScore(getRandom());
        result.setMathematicsScore(getRandom());
        result.setJapaneseScore(getRandom());
        resultList.add(result);

        return resultList;
    }

    /**
     * 0`100̃_ȐlԂ\bh
     * @return 0`100̃_Ȑl
     */
    private int getRandom() {
        double random = Math.random();
        return (int)(random * 100);
    }

    public void setFocus() {

    }

    /**
     * TableViewer̃ZȈsNX 
     */
    class TestResultTableMouseAdapter extends MouseAdapter {

        private TableViewer viewer_;
        
        public TestResultTableMouseAdapter(TableViewer viewer){
            viewer_ = viewer;
        }
        
        /**
         * }EXNbN̏
         * 
         * NbNꂽZ肵AҏW[hɐ؂ւ
         */
        public void mouseDown(MouseEvent e) {
            int x = e.x;
            int y = e.y;
            Table messageTable = (Table)e.getSource();

            // NbNꂽ|Cge[uACe擾
            Point clickPoint = new Point(x, y);

            Table table = viewer_.getTable();
            int startRwoNum = table.getTopIndex();
            int endRowNum = table.getItemCount();
            int columnCount = table.getColumnCount();

            TableItem targetItem = null;
            int columnIndex = 0;
            // sŃ[v
            for (int rowCnt = startRwoNum; rowCnt < endRowNum; rowCnt++) {
                TableItem item = table.getItem( rowCnt);
                // Ń[v
                for (int colCnt = 0; colCnt <= columnCount; colCnt++) {
                    Rectangle rect = item.getBounds(colCnt);
                    // NbNꂽZ肷B
                    if (rect.contains(clickPoint)) {
                        columnIndex = colCnt;
                        targetItem = item;
                        break;
                    }
                }
            }

            // ҏW[hIɂ
            if (targetItem != null) {
                int rowIndex = messageTable.indexOf(targetItem);
                viewer_.editElement(targetItem.getData(), columnIndex);
            }
        }
    }
}
